using System;

namespace Kvalifikacije
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[] opisGrupe = new string[n];
            int[] potrebePacijenta = new int[n];
            string[] pomoc = Console.ReadLine().Split();
            int o = int.Parse(pomoc[0]), a = int.Parse(pomoc[1]), b = int.Parse(pomoc[2]), ab = int.Parse(pomoc[3]);
            for (int i = 0; i < n; i++)
            {
                pomoc = Console.ReadLine().Split();
                opisGrupe[i] = pomoc[0];
                potrebePacijenta[i] = int.Parse(pomoc[1]);
            }
            int[,] raspored = new int[n, 4];
            // Rasporedi krvnu grupu A
            for (int i = 0; i < n; i++)
            {
                if (opisGrupe[i] == "A")
                {
                    if (potrebePacijenta[i] > a)
                    {
                        raspored[i, 1] = a;
                        potrebePacijenta[i] -= a;
                        a = 0;
                    }
                    else
                    {
                        raspored[i, 1] = potrebePacijenta[i];
                        a -= potrebePacijenta[i];
                        potrebePacijenta[i] = 0;
                    }
                }
            }
            // Rasporedi krvnu grupu B
            for (int i = 0; i < n; i++)
            {
                if (opisGrupe[i] == "B")
                {
                    if (potrebePacijenta[i] > b)
                    {
                        raspored[i, 2] = b;
                        potrebePacijenta[i] -= b;
                        b = 0;
                    }
                    else
                    {
                        raspored[i, 2] = potrebePacijenta[i];
                        b -= potrebePacijenta[i];
                        potrebePacijenta[i] = 0;
                    }
                }
            }

            // Raspore]ujemo krvnu grupu O
            for (int i = 0; i < n; i++)
            {
                raspored[i, 0] = potrebePacijenta[i];
                o -= potrebePacijenta[i];
            }

            if (o<0)
            {
                Console.WriteLine("nemoguce");
            }
            else
            {
                Console.WriteLine("moguce");
                for (int i = 0; i < n; i++)
                {
                    for (int j=0; j < 4; j++)
                    {
                        Console.Write(raspored[i, j]+" ");
                    }
                    Console.WriteLine();
                }
            }
        }
    }
}